/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


Main();


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // création du module AngularJS         
    var oModule = angular.module("AppliAngularJS", []);

    // déclaration des contrôleurs
    oModule.controller("MainControler", MainControler) 
      .controller("ViewControler", ViewControler)
      .service("MathService", MathService)
      .service("CalculatorService", CalculatorService)
      .controller("CalculatorController", CalculatorController);

}




/**
 * Création d'un service avec plusieurs méthodes
 * 
 * @param {[type]} $scope [description]
 */
function CalculatorService(MathService)
{ 
    // les méthodes du service
    this.square = function(a) { return MathService.multiply(a,a); };
    this.cube = function(a) { return MathService.multiply(a, MathService.multiply(a,a)); };
} 




/**
 * Création d'un service avec plusieurs méthodes
 * 
 * @param {[type]} $scope [description]
 */
function MathService()
{ 
    // les méthodes du service
    this.add = function(a, b) { return a + b };
    this.subtract = function(a, b) { return a - b };
    this.multiply = function(a, b) { return a * b };
    this.divide = function(a, b) { return a / b };
} 



/**
 * Création d'un service
 * 
 * @param {[type]} $scope [description]
 */
function CalculatorController($scope, CalculatorService) 
{ 
    $scope.doSquare = function() {
        $scope.answer = CalculatorService.square($scope.number);
    }

    $scope.doCube = function() {
        $scope.answer = CalculatorService.cube($scope.number);
    }
} 
   


/**
 * Déclaration des variables des vues
 * 
 * @param {[type]} $scope [description]
 */
function ViewControler($scope) 
{ 
    $scope.pageTitle = "Utilisation d'AngularJS"; 
} 
     

/**
 * Déclaration des variables nécessaires dans la zone gérée par AngularJS
 * 
 * @param {[type]} $scope [description]
 */
function MainControler($scope) 
{
    // représentation du modèle - les données
    $scope.user = { name: "Matthieu", site: "Développement Facile" }; 
    $scope.title = "Application Développement Facile"; 
} 
 

